/*
		A basic implementation of the JFrame class.
*/

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import com.sun.java.swing.*;
import com.sun.java.swing.plaf.metal.*;
import com.sun.java.swing.preview.*;

public class Metalworks extends com.sun.java.swing.JFrame
{
    static final Integer DOCLAYER = new Integer(5);
    static final Integer HELPLAYER = new Integer(7);
    static final String  ABOUTMSG = "Based on the oringal Metalworks example written by the Look&Feel team at Sun\nThis version shows how to create an equivilent using Visual Cafe\'s GUI building facilities.";
    
    public JDesktopPane desktop=new JDesktopPane();
    
    ButtonGroup themeGroup = new ButtonGroup();
    
	public Metalworks()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setJMenuBar(JMenuBar1);
		setTitle("Metalworks");
		setDefaultCloseOperation(com.sun.java.swing.JFrame.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(640,480);
		setVisible(false);
		//$$ JMenuBar1.move(24,372);
		fileMenu.setText("File");
		fileMenu.setActionCommand("File");
		fileMenu.setMnemonic((int)'F');
		JMenuBar1.add(fileMenu);
		newMenu.setText("New");
		newMenu.setActionCommand("New");
		newMenu.setMnemonic((int)'N');
		fileMenu.add(newMenu);
		openMenu.setText("Open");
		openMenu.setActionCommand("Open");
		openMenu.setMnemonic((int)'O');
		fileMenu.add(openMenu);
		fileMenu.add(JSeparator1);
		quitMenu.setText("Quit");
		quitMenu.setActionCommand("Quit");
		quitMenu.setMnemonic((int)'Q');
		fileMenu.add(quitMenu);
		editMenu.setText("Edit");
		editMenu.setActionCommand("Edit");
		editMenu.setMnemonic((int)'E');
		JMenuBar1.add(editMenu);
		undoMenu.setEnabled(false);
		undoMenu.setText("Undo");
		undoMenu.setActionCommand("Undo");
		undoMenu.setAccelerator(com.sun.java.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, Event.CTRL_MASK));
		editMenu.add(undoMenu);
		editMenu.add(JSeparator2);
		cutMenu.setEnabled(false);
		cutMenu.setText("Cut");
		cutMenu.setActionCommand("Cut");
		cutMenu.setAccelerator(com.sun.java.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, Event.CTRL_MASK));
		cutMenu.setMnemonic((int)'U');
		editMenu.add(cutMenu);
		copyMenu.setEnabled(false);
		copyMenu.setText("Copy");
		copyMenu.setActionCommand("Copy");
		copyMenu.setAccelerator(com.sun.java.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, Event.CTRL_MASK));
		copyMenu.setMnemonic((int)'O');
		editMenu.add(copyMenu);
		pasteMenu.setEnabled(false);
		pasteMenu.setText("Paste");
		pasteMenu.setActionCommand("Paste");
		pasteMenu.setAccelerator(com.sun.java.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, Event.CTRL_MASK));
		pasteMenu.setMnemonic((int)'P');
		editMenu.add(pasteMenu);
		editMenu.add(JSeparator3);
		preferencesMenu.setText("Preferences");
		preferencesMenu.setActionCommand("Preferences");
		preferencesMenu.setMnemonic((int)'R');
		editMenu.add(preferencesMenu);
		viewsMenu.setText("Views");
		viewsMenu.setActionCommand("Views");
		viewsMenu.setMnemonic((int)'V');
		JMenuBar1.add(viewsMenu);
		openInboxMenu.setText("Open In-box");
		openInboxMenu.setActionCommand("Open In-box");
		openInboxMenu.setMnemonic((int)'I');
		viewsMenu.add(openInboxMenu);
		openOutboxMenu.setEnabled(false);
		openOutboxMenu.setText("Open Out-Box");
		openOutboxMenu.setActionCommand("Open Out-Box");
		openOutboxMenu.setMnemonic((int)'O');
		viewsMenu.add(openOutboxMenu);
		themesMenu.setText("Theme");
		themesMenu.setActionCommand("Theme");
		themesMenu.setMnemonic((int)'T');
		JMenuBar1.add(themesMenu);
		steelMenu.setText("Steel");
		steelMenu.setActionCommand("Steel");
		steelMenu.setSelected(true);
		themesMenu.add(steelMenu);
		emeraldMenu.setText("Emerald");
		emeraldMenu.setActionCommand("Emerald");
		themesMenu.add(emeraldMenu);
		oxideMenu.setText("Oxide");
		oxideMenu.setActionCommand("Oxide");
		themesMenu.add(oxideMenu);
		sandstoneMenu.setText("Sandstone");
		sandstoneMenu.setActionCommand("Sandstone");
		themesMenu.add(sandstoneMenu);
		presentationMenu.setText("Presentation");
		presentationMenu.setActionCommand("Presentation");
		themesMenu.add(presentationMenu);
		contrastMenu.setText("Contrast");
		contrastMenu.setActionCommand("Contrast");
		themesMenu.add(contrastMenu);
		lowvisionMenu.setText("Low Vision");
		lowvisionMenu.setActionCommand("Low-Vision");
		themesMenu.add(lowvisionMenu);
		charcoalMenu.setText("Charcoal");
		charcoalMenu.setActionCommand("Charcoal");
		themesMenu.add(charcoalMenu);
		helpMenu.setText("Help");
		helpMenu.setActionCommand("Help");
		helpMenu.setMnemonic((int)'H');
		JMenuBar1.add(helpMenu);
		aboutMenu.setText("About");
		aboutMenu.setActionCommand("About");
		aboutMenu.setAccelerator(com.sun.java.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, Event.SHIFT_MASK|Event.CTRL_MASK));
		aboutMenu.setMnemonic((int)'A');
		helpMenu.add(aboutMenu);
		openHelpMenu.setText("Open Help Window");
		openHelpMenu.setActionCommand("Open Help Window");
		helpMenu.add(openHelpMenu);
		//}}
        
        themeGroup.add(steelMenu);
        themeGroup.add(emeraldMenu);
        themeGroup.add(oxideMenu);
        themeGroup.add(sandstoneMenu);
        themeGroup.add(presentationMenu);
        themeGroup.add(contrastMenu);
        themeGroup.add(lowvisionMenu);
        themeGroup.add(charcoalMenu);
        
        getContentPane().add("Center", desktop);
        
        UIManager.addPropertyChangeListener(
            new PropertyChangeListener()
            {
                public void propertyChange(PropertyChangeEvent pe)
                {
                    if((pe!=null)&&("lookAndFeel".equals(pe.getPropertyName())))
                    {
                        SwingUtilities.updateComponentTreeUI(Metalworks.this);
                        invalidate();
                        validate();
                        repaint();
                    }
                }
            }
        );
        
		//{{INIT_MENUS
		//}}
	
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymItem lSymItem = new SymItem();
		emeraldMenu.addItemListener(lSymItem);
		steelMenu.addItemListener(lSymItem);
		oxideMenu.addItemListener(lSymItem);
		sandstoneMenu.addItemListener(lSymItem);
		presentationMenu.addItemListener(lSymItem);
		contrastMenu.addItemListener(lSymItem);
		lowvisionMenu.addItemListener(lSymItem);
		charcoalMenu.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		newMenu.addActionListener(lSymAction);
		openMenu.addActionListener(lSymAction);
		quitMenu.addActionListener(lSymAction);
		preferencesMenu.addActionListener(lSymAction);
		openInboxMenu.addActionListener(lSymAction);
		aboutMenu.addActionListener(lSymAction);
		openHelpMenu.addActionListener(lSymAction);
		//}}
	}

	static public void main(String args[])
	{
	    try
	    {
	        MetalLookAndFeel.setCurrentTheme(new DefaultMetalTheme());
	        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
	    }
	    catch(Exception e)
	    {
	        System.out.println("Metal Look and Feel error");
	        e.printStackTrace();
	        System.exit(0);
	    }
	    
		Metalworks m = new Metalworks();
		m.setLocation(50,50);
		m.setVisible(true);
	}

	//{{DECLARE_CONTROLS
	com.sun.java.swing.JMenuBar JMenuBar1 = new com.sun.java.swing.JMenuBar();
	com.sun.java.swing.JMenu fileMenu = new com.sun.java.swing.JMenu();
	com.sun.java.swing.JMenuItem newMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenuItem openMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JSeparator JSeparator1 = new com.sun.java.swing.JSeparator();
	com.sun.java.swing.JMenuItem quitMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenu editMenu = new com.sun.java.swing.JMenu();
	com.sun.java.swing.JMenuItem undoMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JSeparator JSeparator2 = new com.sun.java.swing.JSeparator();
	com.sun.java.swing.JMenuItem cutMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenuItem copyMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenuItem pasteMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JSeparator JSeparator3 = new com.sun.java.swing.JSeparator();
	com.sun.java.swing.JMenuItem preferencesMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenu viewsMenu = new com.sun.java.swing.JMenu();
	com.sun.java.swing.JMenuItem openInboxMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenuItem openOutboxMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenu themesMenu = new com.sun.java.swing.JMenu();
	com.sun.java.swing.JRadioButtonMenuItem steelMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem emeraldMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem oxideMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem sandstoneMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem presentationMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem contrastMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem lowvisionMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JRadioButtonMenuItem charcoalMenu = new com.sun.java.swing.JRadioButtonMenuItem();
	com.sun.java.swing.JMenu helpMenu = new com.sun.java.swing.JMenu();
	com.sun.java.swing.JMenuItem aboutMenu = new com.sun.java.swing.JMenuItem();
	com.sun.java.swing.JMenuItem openHelpMenu = new com.sun.java.swing.JMenuItem();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == Metalworks.this)
				metalworks_windowClosing(event);
		}
	}

	void metalworks_windowClosing(java.awt.event.WindowEvent event)
	{
		System.exit(0);
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == emeraldMenu)
				emeraldMenu_itemStateChanged(event);
			else if (object == steelMenu)
				steelMenu_itemStateChanged(event);
			else if (object == oxideMenu)
				oxideMenu_itemStateChanged(event);
			else if (object == sandstoneMenu)
				sandstoneMenu_itemStateChanged(event);
			else if (object == presentationMenu)
				presentationMenu_itemStateChanged(event);
			else if (object == contrastMenu)
				contrastMenu_itemStateChanged(event);
			else if (object == lowvisionMenu)
				lowvisionMenu_itemStateChanged(event);
			else if (object == charcoalMenu)
				charcoalMenu_itemStateChanged(event);
		}
	}

	void steelMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(steelMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new DefaultMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void emeraldMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(emeraldMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new GreenMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void oxideMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(oxideMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new AquaMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void sandstoneMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(sandstoneMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new KhakiMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void presentationMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(presentationMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new DemoMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void contrastMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(contrastMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new ContrastMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void lowvisionMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(lowvisionMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new BigContrastMetalTheme());
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	void charcoalMenu_itemStateChanged(java.awt.event.ItemEvent event)
	{
		if(charcoalMenu.isSelected())
		{
		    try
		    {
		        MetalLookAndFeel.setCurrentTheme(new PropertiesMetalTheme(new java.io.FileInputStream("MyTheme.theme")));
		        UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
		    }
		    catch(Exception e)
		    {
		        e.printStackTrace();
		    }
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == newMenu)
				newMenu_actionPerformed(event);
			else if (object == openMenu)
				openMenu_actionPerformed(event);
			else if (object == quitMenu)
				quitMenu_actionPerformed(event);
			else if (object == preferencesMenu)
				preferencesMenu_actionPerformed(event);
			else if (object == openInboxMenu)
				openInboxMenu_actionPerformed(event);
			else if (object == aboutMenu)
				aboutMenu_actionPerformed(event);
			else if (object == openHelpMenu)
				openHelpMenu_actionPerformed(event);
		}
	}

	void newMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
	    try
	    {
		    MailDocument m = new MailDocument();
		    desktop.add(m, DOCLAYER);
		    m.setSelected(true);
		}
		catch(Exception e)
		{
		    e.printStackTrace();
		}
	}

	void openMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
		JFileChooser jc = new JFileChooser();
		jc.showOpenDialog(desktop);
	}

	void quitMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
		System.exit(0);
	}

	void preferencesMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
		PrefsDialog dialog = new PrefsDialog(this);
		dialog.setVisible(true);
	}

	void openInboxMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
	    try
	    {
		    InboxWindow in = new InboxWindow();
		    desktop.add(in, DOCLAYER);
		    in.setSelected(true);
		}
		catch (Exception e)
		{
		    e.printStackTrace();
		}
	}

	void aboutMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
		JOptionPane.showInternalMessageDialog(desktop, ABOUTMSG, "About", JOptionPane.INFORMATION_MESSAGE);
	}

	void openHelpMenu_actionPerformed(java.awt.event.ActionEvent event)
	{
	    try
	    {
		    HelpWindow in = new HelpWindow();
		    desktop.add(in, HELPLAYER);
		    in.setSelected(true);
		}
		catch(Exception e)
		{
		    e.printStackTrace();
		}
	}
}